using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Text.RegularExpressions;
using System.Threading;
using System.Globalization;
using Excel = Microsoft.Office.Interop.Excel;

namespace Project1
{

  public class XlTreadTest {

    private System.Windows.Forms.Form Owner = null;

    public XlTreadTest (System.Windows.Forms.Form fm) {
      Owner = fm;
    }

    public static string xlRCtoA1(int ARow, int ACol) {
      int A1 = Convert.ToByte('A') - 1;  //  "A"  1 (65 - 1 = 64)
      int AZ = Convert.ToByte('Z') - A1; // -   .  (90 - 64 = 26)
      string s;
      //
      if (ACol <= AZ) s = Convert.ToString(Convert.ToChar(A1 + ACol));
      else {
        if ((ACol % AZ) == 0) {
          s = string.Format("{0}{1}",
            Convert.ToChar(A1 + ACol / AZ - 1),
            Convert.ToChar(A1 + AZ));
        }
        else {
          s = string.Format("{0}{1}",
            Convert.ToChar(A1 + ACol / AZ),
            Convert.ToChar(A1 + ACol % AZ));
        }
      }
      return s + ARow.ToString("d");
    }

    public void Execute() {
      Excel.Worksheet oSheet;
      Excel.Application XL = new Excel.Application();
      try
      {
        XL.Visible = true;
        if (Owner != null) Owner.Activate();

        XL.Workbooks.Add(Type.Missing);
        oSheet = (Excel.Worksheet) XL.ActiveSheet;
        int i = 0;
        int Color;
        for (int R= 1; R <= 33; R++) {
          for (int C = 1; C <= 56; C++) {
            Color =  i + C;
            if (Color > 56) Color -= 56;
            oSheet.get_Range(xlRCtoA1(R, C), Type.Missing).Interior.ColorIndex =  Color;
//            ((Excel.Range) oSheet.Cells[R, C]).Interior.ColorIndex =  Color;
            Thread.Sleep(0);
          }
          i++;
          if (i > 56) i = 0;
        }
      }
      finally
      {
        oSheet = null;
        XL.UserControl = true;
        XL = null;
      }
    }
  }

  /// <summary>
  /// Summary description for WinForm.
  /// </summary>
  public class WinForm : System.Windows.Forms.Form
  {
    /// <summary>
    /// Required designer variable.
    /// </summary>
    private System.ComponentModel.Container components = null;
    private System.Windows.Forms.TabControl tabControl1;
    private System.Windows.Forms.TabPage tabPage1;
    private System.Windows.Forms.TabPage tabPage2;
    private System.Windows.Forms.LinkLabel linkLabel1;
    private System.Data.OleDb.OleDbConnection oleDbConnection1;
    private System.Data.OleDb.OleDbCommand oleDbInsertCommand1;
    private System.Data.OleDb.OleDbCommand oleDbUpdateCommand1;
    private System.Data.OleDb.OleDbCommand oleDbDeleteCommand1;
    private System.Data.OleDb.OleDbDataAdapter oleDbDataAdapter1;
    private System.Data.DataSet dataSet1;
    private System.Data.OleDb.OleDbCommand oleDbCommand1;
    private System.Windows.Forms.DataGrid dataGrid1;
    private System.Windows.Forms.LinkLabel linkLabel2;
    private System.Windows.Forms.LinkLabel linkLabel3;
    private System.Windows.Forms.LinkLabel linkLabel4;
    private System.Windows.Forms.LinkLabel linkLabel5;
    private System.Windows.Forms.LinkLabel linkLabel6;
    private System.Windows.Forms.LinkLabel linkLabel7;
    private System.Windows.Forms.LinkLabel linkLabel8;
    private System.Windows.Forms.LinkLabel linkLabel9;

    public WinForm()
    {
      //
      // Required for Windows Form Designer support
      //
      InitializeComponent();

      //
      // TODO: Add any constructor code after InitializeComponent call
      //
    }

    /// <summary>
    /// Clean up any resources being used.
    /// </summary>
    protected override void Dispose(bool disposing)
    {
      if (disposing)
      {
        if (components != null)
        {
          components.Dispose();
        }
      }
      base.Dispose(disposing);
    }

    #region Windows Form Designer generated code
    /// <summary>
    /// Required method for Designer support - do not modify
    /// the contents of this method with the code editor.
    /// </summary>
    private void InitializeComponent()
    {
      this.tabControl1 = new System.Windows.Forms.TabControl();
      this.tabPage1 = new System.Windows.Forms.TabPage();
      this.linkLabel6 = new System.Windows.Forms.LinkLabel();
      this.linkLabel5 = new System.Windows.Forms.LinkLabel();
      this.linkLabel4 = new System.Windows.Forms.LinkLabel();
      this.linkLabel3 = new System.Windows.Forms.LinkLabel();
      this.linkLabel2 = new System.Windows.Forms.LinkLabel();
      this.tabPage2 = new System.Windows.Forms.TabPage();
      this.linkLabel9 = new System.Windows.Forms.LinkLabel();
      this.linkLabel8 = new System.Windows.Forms.LinkLabel();
      this.linkLabel7 = new System.Windows.Forms.LinkLabel();
      this.dataGrid1 = new System.Windows.Forms.DataGrid();
      this.linkLabel1 = new System.Windows.Forms.LinkLabel();
      this.oleDbConnection1 = new System.Data.OleDb.OleDbConnection();
      this.oleDbInsertCommand1 = new System.Data.OleDb.OleDbCommand();
      this.oleDbUpdateCommand1 = new System.Data.OleDb.OleDbCommand();
      this.oleDbDeleteCommand1 = new System.Data.OleDb.OleDbCommand();
      this.oleDbDataAdapter1 = new System.Data.OleDb.OleDbDataAdapter();
      this.oleDbCommand1 = new System.Data.OleDb.OleDbCommand();
      this.dataSet1 = new System.Data.DataSet();
      this.tabControl1.SuspendLayout();
      this.tabPage1.SuspendLayout();
      this.tabPage2.SuspendLayout();
      ((System.ComponentModel.ISupportInitialize)(this.dataGrid1)).BeginInit();
      ((System.ComponentModel.ISupportInitialize)(this.dataSet1)).BeginInit();
      this.SuspendLayout();
      // 
      // tabControl1
      // 
      this.tabControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
            | System.Windows.Forms.AnchorStyles.Left) 
            | System.Windows.Forms.AnchorStyles.Right)));
      this.tabControl1.Controls.Add(this.tabPage1);
      this.tabControl1.Controls.Add(this.tabPage2);
      this.tabControl1.HotTrack = true;
      this.tabControl1.Location = new System.Drawing.Point(0, 0);
      this.tabControl1.Multiline = true;
      this.tabControl1.Name = "tabControl1";
      this.tabControl1.SelectedIndex = 0;
      this.tabControl1.Size = new System.Drawing.Size(520, 320);
      this.tabControl1.TabIndex = 0;
      // 
      // tabPage1
      // 
      this.tabPage1.Controls.Add(this.linkLabel6);
      this.tabPage1.Controls.Add(this.linkLabel5);
      this.tabPage1.Controls.Add(this.linkLabel4);
      this.tabPage1.Controls.Add(this.linkLabel3);
      this.tabPage1.Controls.Add(this.linkLabel2);
      this.tabPage1.Location = new System.Drawing.Point(4, 22);
      this.tabPage1.Name = "tabPage1";
      this.tabPage1.Size = new System.Drawing.Size(512, 294);
      this.tabPage1.TabIndex = 0;
      this.tabPage1.Text = "Application";
      // 
      // linkLabel6
      // 
      this.linkLabel6.Location = new System.Drawing.Point(8, 104);
      this.linkLabel6.Name = "linkLabel6";
      this.linkLabel6.Size = new System.Drawing.Size(100, 16);
      this.linkLabel6.TabIndex = 4;
      this.linkLabel6.TabStop = true;
      this.linkLabel6.Text = "";
      this.linkLabel6.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.linkLabel6_LinkClicked);
      // 
      // linkLabel5
      // 
      this.linkLabel5.Location = new System.Drawing.Point(8, 80);
      this.linkLabel5.Name = "linkLabel5";
      this.linkLabel5.Size = new System.Drawing.Size(100, 16);
      this.linkLabel5.TabIndex = 3;
      this.linkLabel5.TabStop = true;
      this.linkLabel5.Text = "Workbooks";
      this.linkLabel5.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.linkLabel5_LinkClicked);
      // 
      // linkLabel4
      // 
      this.linkLabel4.Location = new System.Drawing.Point(8, 56);
      this.linkLabel4.Name = "linkLabel4";
      this.linkLabel4.Size = new System.Drawing.Size(488, 16);
      this.linkLabel4.TabIndex = 2;
      this.linkLabel4.TabStop = true;
      this.linkLabel4.Text = "   Excel   ?";
      this.linkLabel4.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.linkLabel4_LinkClicked);
      // 
      // linkLabel3
      // 
      this.linkLabel3.Location = new System.Drawing.Point(8, 32);
      this.linkLabel3.Name = "linkLabel3";
      this.linkLabel3.Size = new System.Drawing.Size(496, 16);
      this.linkLabel3.TabIndex = 1;
      this.linkLabel3.TabStop = true;
      this.linkLabel3.Text = "   Excel\' (   )?";
      this.linkLabel3.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.linkLabel3_LinkClicked);
      // 
      // linkLabel2
      // 
      this.linkLabel2.Location = new System.Drawing.Point(8, 8);
      this.linkLabel2.Name = "linkLabel2";
      this.linkLabel2.Size = new System.Drawing.Size(496, 16);
      this.linkLabel2.TabIndex = 0;
      this.linkLabel2.TabStop = true;
      this.linkLabel2.Text = "  Excel   ?";
      this.linkLabel2.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.linkLabel2_LinkClicked);
      // 
      // tabPage2
      // 
      this.tabPage2.Controls.Add(this.linkLabel9);
      this.tabPage2.Controls.Add(this.linkLabel8);
      this.tabPage2.Controls.Add(this.linkLabel7);
      this.tabPage2.Controls.Add(this.dataGrid1);
      this.tabPage2.Controls.Add(this.linkLabel1);
      this.tabPage2.Location = new System.Drawing.Point(4, 22);
      this.tabPage2.Name = "tabPage2";
      this.tabPage2.Size = new System.Drawing.Size(512, 294);
      this.tabPage2.TabIndex = 1;
      this.tabPage2.Text = "DataBase";
      // 
      // linkLabel9
      // 
      this.linkLabel9.Location = new System.Drawing.Point(8, 56);
      this.linkLabel9.Name = "linkLabel9";
      this.linkLabel9.Size = new System.Drawing.Size(144, 16);
      this.linkLabel9.TabIndex = 4;
      this.linkLabel9.TabStop = true;
      this.linkLabel9.Text = "Workbook as DataBase";
      this.linkLabel9.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.linkLabel9_LinkClicked);
      // 
      // linkLabel8
      // 
      this.linkLabel8.Location = new System.Drawing.Point(8, 40);
      this.linkLabel8.Name = "linkLabel8";
      this.linkLabel8.Size = new System.Drawing.Size(100, 16);
      this.linkLabel8.TabIndex = 3;
      this.linkLabel8.TabStop = true;
      this.linkLabel8.Text = "QueryTable";
      this.linkLabel8.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.linkLabel8_LinkClicked);
      // 
      // linkLabel7
      // 
      this.linkLabel7.Location = new System.Drawing.Point(8, 24);
      this.linkLabel7.Name = "linkLabel7";
      this.linkLabel7.Size = new System.Drawing.Size(152, 16);
      this.linkLabel7.TabIndex = 2;
      this.linkLabel7.TabStop = true;
      this.linkLabel7.Text = "Range.CopyFromRecordSet";
      this.linkLabel7.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.linkLabel7_LinkClicked);
      // 
      // dataGrid1
      // 
      this.dataGrid1.DataMember = "";
      this.dataGrid1.HeaderForeColor = System.Drawing.SystemColors.ControlText;
      this.dataGrid1.Location = new System.Drawing.Point(8, 88);
      this.dataGrid1.Name = "dataGrid1";
      this.dataGrid1.ReadOnly = true;
      this.dataGrid1.Size = new System.Drawing.Size(480, 184);
      this.dataGrid1.TabIndex = 1;
      // 
      // linkLabel1
      // 
      this.linkLabel1.Location = new System.Drawing.Point(8, 8);
      this.linkLabel1.Name = "linkLabel1";
      this.linkLabel1.Size = new System.Drawing.Size(128, 16);
      this.linkLabel1.TabIndex = 0;
      this.linkLabel1.TabStop = true;
      this.linkLabel1.Text = "DB to Excel from Array";
      this.linkLabel1.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.linkLabel1_LinkClicked);
      // 
      // oleDbConnection1
      // 
      this.oleDbConnection1.ConnectionString = "Provider=\"Microsoft.Jet.OLEDB.4.0\";Data Source=\"c:\\Program Files\\" +  
        "Common Files\\Borland Shared\\Data\\dbdemos.mdb\";Persist Security In" +  
        "fo=False";
      // 
      // oleDbDataAdapter1
      // 
      this.oleDbDataAdapter1.DeleteCommand = this.oleDbDeleteCommand1;
      this.oleDbDataAdapter1.InsertCommand = this.oleDbInsertCommand1;
      this.oleDbDataAdapter1.SelectCommand = this.oleDbCommand1;
      this.oleDbDataAdapter1.UpdateCommand = this.oleDbUpdateCommand1;
      // 
      // oleDbCommand1
      // 
      this.oleDbCommand1.CommandText = "select * from Employee";
      this.oleDbCommand1.Connection = this.oleDbConnection1;
      // 
      // dataSet1
      // 
      this.dataSet1.DataSetName = "NewDataSet";
      this.dataSet1.Locale = new System.Globalization.CultureInfo("ru-RU");
      // 
      // WinForm
      // 
      this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
      this.ClientSize = new System.Drawing.Size(520, 357);
      this.Controls.Add(this.tabControl1);
      this.Name = "WinForm";
      this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
      this.Text = "WinForm";
      this.Load += new System.EventHandler(this.WinForm_Load);
      this.tabControl1.ResumeLayout(false);
      this.tabPage1.ResumeLayout(false);
      this.tabPage2.ResumeLayout(false);
      ((System.ComponentModel.ISupportInitialize)(this.dataGrid1)).EndInit();
      ((System.ComponentModel.ISupportInitialize)(this.dataSet1)).EndInit();
      this.ResumeLayout(false);
    }
    #endregion

    /// <summary>
    /// The main entry point for the application.
    /// </summary>
    [STAThread]
    static void Main() 
    {
      Application.Run(new WinForm());
    }
    
    private void linkLabel2_LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)
    {
//      MessageBox.Show(XlTreadTest.xlRCtoA1(1, 53));
      XlTreadTest xlTest = new XlTreadTest(this);
      Thread t = new Thread(new ThreadStart(xlTest.Execute));
//      t.Priority = ThreadPriority.Lowest;
      t.Priority = ThreadPriority.Normal;
      t.Start();
    }

    private void linkLabel1_LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)
    {
      string dbFile = Environment.GetFolderPath(Environment.SpecialFolder.CommonProgramFiles);
      dbFile += @"\Borland Shared\Data\dbdemos.mdb";
      //   dbdemos
      dbFile = Regex.Replace(oleDbConnection1.ConnectionString,
        @"^(?<start>.*?;Data Source=)(?<db>[^;]*)(?<end>;.*)$",
        "${start}" + dbFile + "${end}");
      oleDbConnection1.ConnectionString = dbFile;
      try
      {
//        oleDbConnection1.Open();
        oleDbDataAdapter1.Fill(dataSet1, "employee");
        oleDbConnection1.Close(); //  

        //
        DataTable tblEmployee = dataSet1.Tables["employee"];
        dataGrid1.DataSource = tblEmployee; // dataSet1.Tables["employee"];

        //    
        object[,] arrEmployee = (object[,]) Array.CreateInstance(typeof(object),
          new int[2] {tblEmployee.Rows.Count + 1, tblEmployee.Columns.Count}, //  
          new int[2] {0, 1}); //     

        // 
        for (int i = 0; i < tblEmployee.Columns.Count; i++)
          arrEmployee[0, i + 1] = tblEmployee.Columns[i].Caption;

        // 
        for (int R = 0; R < tblEmployee.Rows.Count; R++)
          for (int C = 0; C < tblEmployee.Columns.Count; C++) {
            arrEmployee[R + 1, C + 1] = tblEmployee.Rows[R][C];
            Application.DoEvents();
          }

        Excel.Worksheet oSheet = null;
        Excel.Range oRng = null;
        Excel.Application XL = new Excel.Application();
        try
        {
          XL.Visible = true;
          XL.Interactive = false;
          XL.Workbooks.Add(Type.Missing);
          oSheet = (Excel.Worksheet) XL.ActiveSheet;
          oRng = oSheet.get_Range(oSheet.Cells[1, 1],
            oSheet.Cells[tblEmployee.Rows.Count + 1, tblEmployee.Columns.Count]);
          oRng.Formula = arrEmployee; //  
          oRng.EntireColumn.AutoFit();
          oRng.Borders.LineStyle = Excel.XlLineStyle.xlContinuous;
          oRng.Borders.Weight = Excel.XlBorderWeight.xlHairline;
          // 
          oRng = oSheet.get_Range(oSheet.Cells[1, 1],
            oSheet.Cells[1, tblEmployee.Columns.Count]);
          oRng.Interior.ColorIndex = 15; // 25% 
          oRng.Interior.Pattern = Excel.XlPattern.xlPatternSolid;
          XL.ActiveWindow.SplitRow = 1;
          XL.ActiveWindow.FreezePanes = true;
          XL.ActiveWindow.DisplayGridlines = false;
          XL.ActiveWorkbook.Saved = true;
          this.Activate();
        }
        finally
        {
          oSheet = null;
          XL.Interactive = true;
          XL.UserControl = true;
          XL = null;
        }
        dataSet1.Tables.Remove(tblEmployee);
      }
      catch (Exception ex)
      {
        if (oleDbConnection1.State == ConnectionState.Open) oleDbConnection1.Close();
        MessageBox.Show(ex.Message);
      }
    }

    private Excel.Application StartExcel(bool asNewInstance)
    {
      Excel.Application XL = null;
      if (!(asNewInstance)) {
        try {
          XL = System.Runtime.InteropServices.Marshal.GetActiveObject("Excel.Application")
            as Excel.Application;
        }
        catch {
          // XL = null;
        }
      }
      if (XL == null) XL = new Excel.Application();
      if (XL.Workbooks.Count == 0) XL.Workbooks.Add(Type.Missing);
      XL.Visible = true;
      return XL;
    }

    private void FinishExcel(Excel.Application XL)
    {
      if (XL != null) {
        XL.ScreenUpdating = true;
        if (! XL.Interactive) XL.Interactive = true;
        XL.UserControl = true;
        if (XL.Workbooks.Count == 0) {
          XL.Quit();
        }
        else {
          if (! XL.Visible) XL.Visible = true;
          XL.ActiveWorkbook.Saved = true;
        }
//        GC.SuppressFinalize(XL);
        System.Runtime.InteropServices.Marshal.ReleaseComObject(XL);
        XL = null;
        GC.Collect();
        GC.GetTotalMemory(true); //   
        //   -    
        // EXCEL.EXE    
      }
    }

    private void linkLabel3_LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)
    {
      Excel.Worksheet oSheet;
      Excel.Application XL = StartExcel(true);
      try
      {
        oSheet = (Excel.Worksheet) XL.ActiveSheet;
        oSheet.get_Range("A1", Type.Missing).Formula = "LanguageIDUI is 0x0" +
          XL.LanguageSettings.get_LanguageID(
          Microsoft.Office.Core.MsoAppLanguageID.msoLanguageIDUI).ToString("x");
      }
      finally
      {
        FinishExcel(XL);
      }
    }
    
    private void linkLabel4_LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)
    {
      Excel.Application XL = StartExcel(true);
      try
      {
        this.Activate();
        Application.DoEvents();
        Thread.Sleep(700);
        XL.Visible = true;
        Thread.Sleep(700);
        this.Activate();
        Application.DoEvents();
        Thread.Sleep(700);
        XL.Visible = true;
        Thread.Sleep(700);
        XL.DisplayAlerts = false;
        XL.Workbooks.Close();
      }
      finally
      {
        FinishExcel(XL);
      }
    }

    private void linkLabel5_LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)
    {
      Excel.Application XL = StartExcel(false);
      Excel.Worksheet oSheet = null;
      int sheetsCnt = 3;
      int savedCult = 0x410;
      try
      {
        savedCult = Thread.CurrentThread.CurrentCulture.LCID;
        Thread.CurrentThread.CurrentCulture = new CultureInfo(0x0409, false);
        Thread.CurrentThread.CurrentUICulture = new CultureInfo(0x0409, false);
        XL.DisplayStatusBar = true;
        sheetsCnt = XL.SheetsInNewWorkbook;
        XL.SheetsInNewWorkbook = 5;
//        Excel.Worksheet oSheet = (Excel.Worksheet) XL.ActiveSheet;
        oSheet = (Excel.Worksheet) XL.Sheets[1];
        XL.StatusBar = "Add Workbook 2";
        XL.Workbooks.Add(Type.Missing);
        XL.StatusBar = "Add Workbook 3";
        XL.Workbooks.Add(Type.Missing);
        XL.StatusBar = "Display book names";
        ((Excel.Workbook) oSheet.Parent).Activate();
        int R = 0;
        foreach (Excel.Workbook WB in XL.Workbooks) {
          oSheet.get_Range("A1", Type.Missing).get_Offset(R, 0).Formula = WB.FullName;
          R++;
        }
        XL.StatusBar = "   ";
        XL.Workbooks.Open(
          Environment.CurrentDirectory + @"\..\..\DbDemos.xls", // FileName
          false, // UpdateLinks
          false, //  ReadOnly
          Type.Missing, // Format
          Type.Missing, // Password
          Type.Missing, // WriteResPassword
          Type.Missing, // IgnoreReadOnlyRecommended
          Type.Missing, // Origin
          Type.Missing, // Delimiter
          true, // Editable
          Type.Missing, //  Notify
          Type.Missing, // Converter
          false, // AddToMru
          Type.Missing, // Local
          Type.Missing // CorruptLoad
          );
        oSheet.get_Range("A5", Type.Missing).Formula = "=rand()*100";
        oSheet.get_Range("A6", Type.Missing).set_Value(
          Excel.XlRangeValueDataType.xlRangeValueDefault, 123.45);
        oSheet.get_Range("A7", Type.Missing).set_Value(
          Type.Missing, 12345);
        XL.StatusBar = false;
        XL.DisplayAlerts = false;
//        XL.Workbooks.Close();
      }
      finally
      {
        if (oSheet != null) {
          System.Runtime.InteropServices.Marshal.ReleaseComObject(oSheet);
          oSheet = null;
        }
        XL.SheetsInNewWorkbook = sheetsCnt;
        Thread.CurrentThread.CurrentCulture = new CultureInfo(savedCult, true);
        Thread.CurrentThread.CurrentUICulture = new CultureInfo(savedCult, true);
        FinishExcel(XL);
      }
    }
    
    private void linkLabel6_LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)
    {
      Excel.Application XL = StartExcel(true);
      try
      {
        try
        {
          Microsoft.Vbe.Interop.VBComponent VBComp =
            XL.ActiveWorkbook.VBProject.VBComponents.Add(
            Microsoft.Vbe.Interop.vbext_ComponentType.vbext_ct_StdModule);
          VBComp.Name = "TestModule";
          //    
          VBComp.CodeModule.AddFromString(
            "Public Sub Test(ByVal ADate As Date)\n" +
            "\tMsgBox \"  VBA!\" & Chr(13) & \" \" & ADate, _\n" +
            "\t\tvbInformation, \"Test \"\n" +
            "End Sub");
//          DateTime curDate = ;
          XL.Run("Test", DateTime.Today,
            Type.Missing, Type.Missing, Type.Missing, Type.Missing, Type.Missing,
            Type.Missing, Type.Missing, Type.Missing, Type.Missing, Type.Missing,
            Type.Missing, Type.Missing, Type.Missing, Type.Missing, Type.Missing,
            Type.Missing, Type.Missing, Type.Missing, Type.Missing, Type.Missing,
            Type.Missing, Type.Missing, Type.Missing, Type.Missing, Type.Missing,
            Type.Missing, Type.Missing, Type.Missing, Type.Missing
          );
        }
        catch
        {
          this.Activate();
          MessageBox.Show("    Excel'\n" +
            "\"   Visual Basic Project\"");
        }
      }
      finally
      {
        FinishExcel(XL);
      }
    }

    private void linkLabel7_LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)
    {
      // How to transfer data to an Excel workbook by using Visual C# 2005 or Visual C# .NET
      // http://support.microsoft.com/default.aspx?scid=kb;EN-US;306023
      // DataBase
      ADODB.Connection objConn = new ADODB.Connection();
      ADODB._Recordset objRS = null;
      object objRecAff = null;
      // Excel
      Excel.Worksheet oSheet = null;
      Excel.Range oRng = null;
      Excel.Application XL = new Excel.Application();
      try {
        XL.Visible = true;
        objConn.Open("Provider=\"Microsoft.Jet.OLEDB.4.0\";Data Source=\"" +
          Environment.GetFolderPath(Environment.SpecialFolder.CommonProgramFiles) +
          "\\Borland Shared\\Data\\dbdemos.mdb\";Persist Security Info=False;",
          "", "", 0);
        objRS = (ADODB._Recordset) objConn.Execute("employee", out objRecAff,
          (int) ADODB.CommandTypeEnum.adCmdTable);

        XL.Workbooks.Add(Type.Missing);  
        oSheet = (Excel.Worksheet) XL.ActiveSheet;
        oRng = oSheet.get_Range("A1", Type.Missing);
        for (int i = 0; i < objRS.Fields.Count; i++) {
          oRng.get_Offset(0, i).Value2 = objRS.Fields[i].Name;
        }
        oRng = oSheet.get_Range("A2", Type.Missing);
        oRng.CopyFromRecordset(objRS, Type.Missing, Type.Missing);
        oRng = oSheet.UsedRange.EntireColumn;
        oRng.AutoFit();
        XL.ActiveWorkbook.Saved = true;
      }
      finally {
        objConn.Close();
        objConn = null;
        objRS = null;
        objRecAff = null;
        oRng = null;
        oSheet = null;
        XL.UserControl = true;
        XL = null;
        GC.GetTotalMemory(true);
      }
    }

    private void linkLabel8_LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)
    {
      Excel.Worksheet oSheet = null;
      Excel.Range oRng = null;
      Excel.QueryTable oQT = null;
      Excel.Application XL = new Excel.Application();
      try
      {
        XL.Visible = true;
        XL.Workbooks.Add(Type.Missing);  
        oSheet = (Excel.Worksheet) XL.ActiveSheet;
        oRng = oSheet.get_Range("A1", Type.Missing);
        oQT = (Excel.QueryTable) oSheet.QueryTables.Add(
          "OLEDB;Provider=\"Microsoft.Jet.OLEDB.4.0\";Data Source=\"" +
          Environment.GetFolderPath(Environment.SpecialFolder.CommonProgramFiles) +
          "\\Borland Shared\\Data\\dbdemos.mdb\";Persist Security Info=False;",
          oRng,
          "select * from Employee"
        );
        oQT.RefreshStyle = Excel.XlCellInsertionMode.xlInsertEntireRows;
        oQT.Refresh(false);
        XL.ActiveWorkbook.Saved = true;
      }
      finally
      {
        oQT = null;
        oRng = null;
        oSheet = null;
        XL.UserControl = true;
        XL = null;
        GC.GetTotalMemory(true);
      }
    }

    private void linkLabel9_LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)
    {
      System.Data.OleDb.OleDbConnection oConn = new System.Data.OleDb.OleDbConnection();
      System.Data.OleDb.OleDbCommand oCmd = new System.Data.OleDb.OleDbCommand();
      System.Data.OleDb.OleDbDataAdapter oAdapt = new System.Data.OleDb.OleDbDataAdapter();
      System.Data.DataSet oDS = new System.Data.DataSet("DbDemos");
      try
      {
        oConn.ConnectionString =
          "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" +
          Environment.CurrentDirectory + @"\..\..\DbDemos.xls;" +
          "Extended Properties=\"Excel 8.0;HDR=Yes;\";";
        oCmd.Connection = oConn;
//        oCmd.CommandText = "select * from [Employee$]";
//        oCmd.CommandText = "select * from MyRange";
//        oCmd.CommandText = "select * from [Employee$A10:F40]";
        oCmd.CommandText =
          "SELECT O.OrderNo, O.SaleDate, O.PaymentMethod, O.ItemsTotal,\n" +
          "E.FirstName, E.LastName, C.Company\n" +
          "FROM [customer$] AS C\n" +
          "  INNER JOIN ([employee$] AS E\n" +
          "  INNER JOIN [orders$] AS O ON E.EmpNo = O.EmpNo)\n" +
          "  ON C.CustNo = O.CustNo";
        oAdapt.SelectCommand = oCmd;
//        oAdapt.Fill(oDS, "Employee");
        oAdapt.Fill(oDS, "Employee");
        dataGrid1.DataSource = oDS.Tables["Employee"];
      }
      finally
      {
        oConn.Close();
      }
    }
    
    private void WinForm_Load(object sender, System.EventArgs e)
    {
      Application.EnableVisualStyles();
    }
  }
}
